Crashpad

Public Member Functions | Protected Member Functions | List of all members
crashpad::MinidumpModuleListWriter Class Referencefinal

The writer for a MINIDUMP_MODULE_LIST stream in a minidump file, containing a list of MINIDUMP_MODULE objects. More...

`#include "minidump/minidump_module_writer.h"`

Inheritance diagram for crashpad::MinidumpModuleListWriter:

## Public Member Functions
void | InitializeFromSnapshot (const std::vector< const ModuleSnapshot *> &module_snapshots)
| Adds an initialized MINIDUMP_MODULE for each module in module_snapshots to the MINIDUMP_MODULE_LIST. More...
void | AddModule (std::unique_ptr< MinidumpModuleWriter > module)
| Adds a MinidumpModuleWriter to the MINIDUMP_MODULE_LIST. More...
Public Member Functions inherited from crashpad::internal::MinidumpStreamWriter
const MINIDUMP_DIRECTORY * | DirectoryListEntry () const
| Returns a MINIDUMP_DIRECTORY entry that serves as a pointer to this stream. More...
Public Member Functions inherited from crashpad::internal::MinidumpWritable
virtual bool | WriteEverything (FileWriterInterface *file_writer)
| Writes an object and all of its children to a minidump file. More...
void | RegisterRVA (RVA *rva)
| Registers a file offset pointer as one that should point to the object on which this method is called. More...
void | RegisterLocationDescriptor (MINIDUMP_LOCATION_DESCRIPTOR *location_descriptor)
| Registers a location descriptor as one that should point to the object on which this method is called. More...

## Protected Member Functions
bool | Freeze () override
| Transitions the object from kStateMutable to kStateFrozen. More...
size_t | SizeOfObject () override
| Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment. More...
std::vector< MinidumpWritable * > | Children () override
| Returns the object’s children. More...
bool | WriteObject (FileWriterInterface *file_writer) override
| Writes the object’s content. More...
MinidumpStreamType | StreamType () const override
| Returns an object’s stream type. More...
Protected Member Functions inherited from crashpad::internal::MinidumpStreamWriter
bool | Freeze () override
| Transitions the object from kStateMutable to kStateFrozen. More...
Protected Member Functions inherited from crashpad::internal::MinidumpWritable
State | state () const
| The state of the object.
virtual size_t | Alignment ()
| Returns the object’s desired byte-boundary alignment. More...
virtual Phase | WritePhase ()
| Returns the object’s desired write phase. More...
size_t | WillWriteAtOffset (Phase phase, FileOffset *offset, std::vector< MinidumpWritable *> *write_sequence)
| Prepares the object to be written at a known file offset, transitioning it from kStateFrozen to kStateWritable. More...
virtual bool | WillWriteAtOffsetImpl (FileOffset offset)
| Called once an object’s writable file offset is determined, as it transitions into kStateWritable. More...
bool | WritePaddingAndObject (FileWriterInterface *file_writer)
| Writes the object, transitioning it from kStateWritable to kStateWritten. More...

## Additional Inherited Members
Protected Types inherited from crashpad::internal::MinidumpWritable
enum | State
| Identifies the state of an object. More...
enum | Phase
| Identifies the phase during which an object will be written to a minidump file. More...
Static Protected Attributes inherited from crashpad::internal::MinidumpWritable
static const size_t | kInvalidSize
| A size value used to signal failure by methods that return `size_t`. More...

## Detailed Description

The writer for a MINIDUMP_MODULE_LIST stream in a minidump file, containing a list of MINIDUMP_MODULE objects.

## Member Function Documentation

## ◆ AddModule()

void crashpad::MinidumpModuleListWriter::AddModule | ( | std::unique_ptr< MinidumpModuleWriter > | module | ) |

Adds a MinidumpModuleWriter to the MINIDUMP_MODULE_LIST.

This object takes ownership of module and becomes its parent in the overall tree of internal::MinidumpWritable objects.

Note
  Valid in kStateMutable.

## ◆ Children()

std::vector< internal::MinidumpWritable * > crashpad::MinidumpModuleListWriter::Children | ( |  | ) |
| override protected virtual

Returns the object’s children.

Note
  Valid in kStateFrozen or any subsequent state.

Reimplemented from crashpad::internal::MinidumpWritable.

## ◆ Freeze()

bool crashpad::MinidumpModuleListWriter::Freeze | ( |  | ) |
| override protected virtual

Transitions the object from kStateMutable to kStateFrozen.

The default implementation marks the object as frozen and recursively calls Freeze() on all of its children. Subclasses may override this method to perform processing that should only be done once callers have finished populating an object with data. Typically, a subclass implementation would call RegisterRVA() or RegisterLocationDescriptor() on other objects as appropriate, because at the time Freeze() runs, the in-memory locations of RVAs and location descriptors are known and will not change for the remaining duration of an object’s lifetime.

Returns
  `true` on success. `false` on failure, with an appropriate message logged.

Reimplemented from crashpad::internal::MinidumpWritable.

## ◆ InitializeFromSnapshot()

void crashpad::MinidumpModuleListWriter::InitializeFromSnapshot | ( | const std::vector< const ModuleSnapshot *> & | module_snapshots | ) |

Adds an initialized MINIDUMP_MODULE for each module in module_snapshots to the MINIDUMP_MODULE_LIST.

Parameters

  [in] | module_snapshots | The module snapshots to use as source data.

Note
  Valid in kStateMutable. AddModule() may not be called before this this method, and it is not normally necessary to call AddModule() after this method.

## ◆ SizeOfObject()

size_t crashpad::MinidumpModuleListWriter::SizeOfObject | ( |  | ) |
| override protected virtual

Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment.

Note
  Valid in kStateFrozen or any subsequent state.

Implements crashpad::internal::MinidumpWritable.

## ◆ StreamType()

MinidumpStreamType crashpad::MinidumpModuleListWriter::StreamType | ( |  | ) | const
| override protected virtual

Returns an object’s stream type.

Note
  Valid in any state.

Implements crashpad::internal::MinidumpStreamWriter.

## ◆ WriteObject()

bool crashpad::MinidumpModuleListWriter::WriteObject | ( | FileWriterInterface * | file_writer | ) |
| override protected virtual

Writes the object’s content.

Parameters

  [in] | file_writer | The file writer to receive the object’s content.

Returns
  `true` on success. `false` on error, indicating that the content could not be written to the minidump file.

Note
  Valid in kStateWritable. The object will transition to kStateWritten after this method returns.

Implements crashpad::internal::MinidumpWritable.

The documentation for this class was generated from the following files:

- minidump/minidump_module_writer.h
- minidump/minidump_module_writer.cc